// Datei: TaxiZentrale.java
import java.util.Vector;

public class TaxiZentrale 
{
   private int size = 2;  // Es gibt leider nur 2 Taxis
   private static TaxiZentrale taxiZentrale = new TaxiZentrale();
   private Vector<Taxi> taxis;
   
   private TaxiZentrale()
   {
      taxis = new Vector<Taxi> (size);
      
      for (int i = 1; i <= size; i++) 
         taxis.add (new Taxi (i));
      System.out.println ("Neue Taxizentrale mit " + size 
         + " verwalteten Taxis erzeugt.");
   }
   
   public static TaxiZentrale gibZentrale() 
   {
      return taxiZentrale;
   }
   
   public synchronized Taxi taxiAnfordern()
   {
      if (taxis.size() > 0)
      {
         Taxi taxi = taxis.get (0);
         taxis.remove (taxi);
         return taxi;
      }
      
      // Kein Taxi frei
      return null;
   }
   
   public synchronized void taxiFreigeben (Taxi taxi)
   {
      taxis.add (taxi);
   }
}
