// Datei: TemperaturDienstProxy.java
public class TemperaturDienstProxy implements ServerProxy {

    private TemperaturDienst temperaturDienst;
    private Broker broker;

    public TemperaturDienstProxy(Broker broker) {
        System.out.println("TemperaturDienstProxy: instanziiert");
        this.broker = broker;
        temperaturDienst = new TemperaturDienst();
        broker.anmelden("erfrageTemperatur", this);
    }

    public void bearbeiteAnfrage(byte[] anfrage) {
        Tag tag = auspacken(anfrage);
        Float temperatur = temperaturDienst.erfrageTemperatur(tag);
        byte[] antwort = verpacken(anfrage, temperatur);
        broker.antwortWeiterleiten(antwort);
    }

    private Tag auspacken(byte[] gepackteNachricht) {
        String string = new String(gepackteNachricht);
        String[] entpackteNachricht = string.split(";");
        Tag tag = Tag.valueOf(entpackteNachricht[2]);
        return tag;
    }

    private byte[] verpacken(byte[] anfrage, Float wert) {
        String[] strings = (new String(anfrage)).split(";");
        return (strings[0] + ";" + wert).getBytes();
    }
}