// Datei: WetterDienstProxy.java
public class WetterDienstProxy implements ServerProxy {

    private WetterDienst wetterDienst;
    private Broker broker;

    public WetterDienstProxy(Broker broker) {
        System.out.println("WetterDienstProxy: instanziiert");
        this.broker = broker;
        wetterDienst = new WetterDienst();
        broker.anmelden("erfrageWetter", this);
    }

    public void bearbeiteAnfrage(byte[] anfrage) {
        Tag tag = auspacken(anfrage);
        String wetter = wetterDienst.erfrageWetter(tag);
        byte[] antwort = verpacken(anfrage, wetter);
        broker.antwortWeiterleiten(antwort);
    }

    private Tag auspacken(byte[] gepackteNachricht) {
        String string = new String(gepackteNachricht);
        String[] entpackteNachricht = string.split(";");
        Tag tag = Tag.valueOf(entpackteNachricht[2]);
        return tag;
    }

    private byte[] verpacken(byte[] anfrage, String ergebnis) {
        String[] strings = (new String(anfrage)).split(";");
        return (strings[0] + ";" + ergebnis).getBytes();
    }
}