package autovermietung.servicenutzer;

import java.util.List;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.WebResource.Builder;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;

// Datei: AutovermietungNutzer.java
public class AutovermietungNutzer {

  public static void main(String[] args) {
    String erg;
    WebResource res;
    String restUrl = "http://localhost:8080/rest/Autovermietung";

    String revierungsNr;
    String standort = "Stuttgart";
    String kreditkartenNr = "abc123456";

    System.out.println("Servicenutzer gestartet.");

    // Verbindung zum Serviceanbieter
    ClientConfig config = new DefaultClientConfig();
    Client client = Client.create(config);
    WebResource baseService = client.resource(restUrl);

    // Alle verfuegbaren Fahrzeuge auflisten
    res = baseService.path("Fahrzeuge/" + standort);
    erg = res.accept(MediaType.TEXT_PLAIN).get(String.class);
    System.out.println("Freie Fahrzeuge in " + standort + ":");
    System.out.println(erg);


    // Ein Fahrzeug reservieren
    System.out.println("Reserviere einen Kleinwagen...");
    res = baseService.path("Reservieren/" + standort + "/Kleinwagen");
    revierungsNr = res.accept(MediaType.TEXT_PLAIN).get(String.class);
    System.out.println("Reserviertes Fahrzeug hat "
        + "die Revierungsnr. " + revierungsNr + ".");


    // Fahrzeug abholen
    res = baseService.path("Abholen/" + revierungsNr);
    res.accept(MediaType.TEXT_PLAIN).get(String.class);
    System.out.println("Fahrzeug abgeholt.");

    // Fahrzeug nutzen...

    // Spaeter Fahrzeug zurueckgeben
    res = baseService.path("Zurueckgeben/"
          + revierungsNr + "/" + kreditkartenNr);
    res.accept(MediaType.TEXT_PLAIN).get(String.class);
    System.out.println("Fahrzeug zurueckgegeben.");
  }
}
