/*
 * Typ   : Interface
 * Name  : ModelInterface
 * Paket : model
 */
package model;

/**
 * Interface fr alle Model Klassen.
 * 
 * @author Vasilios Filippidis
 *
 */
public interface IModelInterface extends IObservableInterface
{
	/**
	 * Liefert den Prozentualen Anteil der roten Partei zurck.
	 * 
	 * @return Prozentualer Anteil der roten Partei.
	 */
	public double getRedPercentage();

	/**
	 * Liefert den Prozentualen Anteil der blauen Partei zurck.
	 * 
	 * @return Prozentualer Anteil der blauen Partei.
	 */
	public double getBluePercentage();
	
	/**
	 * Liefert den Prozentualen Anteil der grnen Partei zurck.
	 * 
	 * @return Prozentualer Anteil der grnen Partei.
	 */	
	public double getGreenPercentage();
	
	/**
	 * Setzt die Anzahl der roten Sitze.
	 * 
	 * @param value Anzahl der roten Sitze.
	 */
	public void setRedValue (int value);

	/**
	 * Setzt die Anzahl der blauen Sitze.
	 * 
	 * @param value Anzahl der blauen Sitze.
	 */
	public void setBlueValue (int value);

	/**
	 * Setzt die Anzahl der grnen Sitze.
	 * 
	 * @param value Anzahl der grnen Sitze.
	 */
	public void setGreenValue (int value);	
}
